#include "stm32f10x.h"

//Structure of CAN
typedef struct		  //size of structure is 517 byte
{
	//Structure of CAN messages
	CanTxMsg		TxMessage;
	CanRxMsg		RxMessage;
	//CAN Flags
	uint8_t			RECEIVE_FLAG; 			//receiving flag
	uint8_t			TRANSMIT_FLAG;			//receiving flag
	uint8_t			CAN_RspRdy;				//response ia ready flag
	//CAN ready flags
	uint8_t			CAN_TxRdy;
	uint8_t			CAN_RxRdy;
}CAN_DATA_STRUCTURE;		

extern 	CAN_DATA_STRUCTURE		CAN_LLP1;
extern	uint8_t			   		CAN_DATA_UPDATED;
extern	uint8_t			   		TEST_DATA_UPDATED;	//,        
extern	uint8_t			   		CAN_PACKET;			//,   ,   1  
extern	uint8_t			   		CAN_SCAN;
