#include "stm32f10x.h"
#include "Modbus_ASCIIDefinitions.h"
//MODBUS DATA TYPES
extern uint16_t	DiscreteInput	[125];
extern uint16_t	Coil			[125];
extern uint16_t	InputRegister	[125];
extern uint16_t	HoldingRegister	[125]; 
//Define buffer for saving registers' data
//Variable that defines usart speed
//extern s32			USART_SPEED;

//Structure of MODBUS
typedef struct		  //size of structure is 517 byte
{
unsigned char	Device_addr;	  //1 byte  
unsigned char MODBUS_FRAME[MAX_FRAME_LENGHT];//256 bytes
unsigned char RESPONSE_FRAME[MAX_FRAME_LENGHT]; //256 bytes
unsigned char	ind_rx;							  //1 byte
unsigned char	ind_tx;							  //1 byte
unsigned char	Received_Frame_Lenght; //received data frame lenght	 1 byte
unsigned char	Transmit_data_lenght;
//Modbus Flags
uint8_t 			StateFlags;	//	
//Definitions for else vars
uint8_t				ExceptionCode;
uint8_t				MODBUS_Error;
unsigned	char	N;			  //byte count	
unsigned	char	subbyte;
unsigned	char	ReadDataBuf[MAX_FRAME_LENGHT-3];   //256-Device_ID-Func-LRC
uint16_t			StartAddr;

unsigned 	char	ResponseStatus;
unsigned 	char	HR_UpdateFlag;
} MODBUS_DATA;
extern 					MODBUS_DATA MODBUS1,MODBUS2;
extern			
uint8_t* MBErrMsg[7];
	