#include 	"stm32f10x.h"
#include 	"Modbus_ASCIIGlobalVars.h"
#include	"Modbus_functions.h"
//(0x17)==================================================================================
void	Read_WriteMulRegister	(MODBUS_DATA *MODBUS)
{
uint16_t	quantity_read=0;
uint16_t	quantity_write=0;
uint16_t	rd_addr=0;
uint16_t	wr_addr=0;
unsigned	char	byte_count=0;
unsigned	char	i=0;
unsigned	char	j=0;
uint16_t	temp=0;

rd_addr=MODBUS->MODBUS_FRAME[DATA_FIELD]*0x100+MODBUS->MODBUS_FRAME[DATA_FIELD+1];
quantity_read=MODBUS->MODBUS_FRAME[DATA_FIELD+2]*0x100+MODBUS->MODBUS_FRAME[DATA_FIELD+3];
wr_addr=MODBUS->MODBUS_FRAME[DATA_FIELD+4]*0x100+MODBUS->MODBUS_FRAME[DATA_FIELD+5];
quantity_write=MODBUS->MODBUS_FRAME[DATA_FIELD+6]*0x100+MODBUS->MODBUS_FRAME[DATA_FIELD+7];
MODBUS->RESPONSE_FRAME[DATA_FIELD]=quantity_read*2;
//write regs
for	(i=0;i<quantity_write;i++)
	{
	HoldingRegister[wr_addr+i]=MODBUS->MODBUS_FRAME[DATA_FIELD+9+i+i]*0x100+MODBUS->MODBUS_FRAME[DATA_FIELD+10+i+i];
	}
//read_regs
byte_count=2*quantity_read;
for	(i=0;i<quantity_read;i++)
	{
	temp=HoldingRegister[rd_addr+i];
	MODBUS->RESPONSE_FRAME[DATA_FIELD+1+j]=temp/0x100;
	MODBUS->RESPONSE_FRAME[DATA_FIELD+2+j]=temp&0xFF;
	j=j+2;
	}
MODBUS->Transmit_data_lenght=3+byte_count;
}
//(6)//////
//(0x10)//=================================================================
void	WriteMultipleRegister	(MODBUS_DATA *MODBUS)
{
uint16_t	start_addr=0;
uint16_t	quantity=0;
unsigned	char	i=0;
start_addr=MODBUS->MODBUS_FRAME[DATA_FIELD]*0x100+MODBUS->MODBUS_FRAME[DATA_FIELD+1];
quantity=MODBUS->MODBUS_FRAME[DATA_FIELD+2]*0x100+MODBUS->MODBUS_FRAME[DATA_FIELD+3];
MODBUS->RESPONSE_FRAME[DATA_FIELD]=MODBUS->MODBUS_FRAME[DATA_FIELD];
MODBUS->RESPONSE_FRAME[DATA_FIELD+1]=MODBUS->MODBUS_FRAME[DATA_FIELD+1];
MODBUS->RESPONSE_FRAME[DATA_FIELD+2]=MODBUS->MODBUS_FRAME[DATA_FIELD+2];
MODBUS->RESPONSE_FRAME[DATA_FIELD+3]=MODBUS->MODBUS_FRAME[DATA_FIELD+3];
while(i<MODBUS->MODBUS_FRAME[DATA_FIELD+3])
	{	
	HoldingRegister[start_addr+i]=MODBUS->MODBUS_FRAME[DATA_FIELD+5+i+i]*0x100+MODBUS->MODBUS_FRAME[DATA_FIELD+6+i+i];
	i++;
	}
MODBUS->Transmit_data_lenght=SIMPLE_DATA_LENGHT;
}
//(7)========
//(0x06)===================================================================
void	WriteSingleRegister	(MODBUS_DATA *MODBUS)
{
uint16_t	output_addr=0;
uint16_t	output_value=0;
output_addr=MODBUS->MODBUS_FRAME[DATA_FIELD]*0x100+MODBUS->MODBUS_FRAME[DATA_FIELD+1];
output_value=MODBUS->MODBUS_FRAME[DATA_FIELD+2]*0x100+MODBUS->MODBUS_FRAME[DATA_FIELD+3];
HoldingRegister[output_addr]=output_value;
MODBUS->RESPONSE_FRAME[DATA_FIELD]=MODBUS->MODBUS_FRAME[DATA_FIELD];
MODBUS->RESPONSE_FRAME[DATA_FIELD+1]=MODBUS->MODBUS_FRAME[DATA_FIELD+1];
MODBUS->RESPONSE_FRAME[DATA_FIELD+2]=MODBUS->MODBUS_FRAME[DATA_FIELD+2];
MODBUS->RESPONSE_FRAME[DATA_FIELD+3]=MODBUS->MODBUS_FRAME[DATA_FIELD+3];
MODBUS->Transmit_data_lenght=SIMPLE_DATA_LENGHT;
}
//(8)-----------------
//(0x03)//=================================================================
void	ReadHoldingRegister(MODBUS_DATA *MODBUS)
{
uint16_t	start_addr=0;
uint16_t	quantity=0;
uint16_t	coil_quantity=0;
unsigned	char	i=0;
unsigned	char	j=0;
uint16_t	temp=0;


start_addr=MODBUS->MODBUS_FRAME[DATA_FIELD]*0x100+MODBUS->MODBUS_FRAME[DATA_FIELD+1];
coil_quantity=MODBUS->MODBUS_FRAME[DATA_FIELD+2]*0x100+MODBUS->MODBUS_FRAME[DATA_FIELD+3];
quantity=coil_quantity;
while	(quantity)
		{
		 temp=HoldingRegister[start_addr+i];
		 MODBUS->ReadDataBuf[j++]=temp/0x100;
		 MODBUS->ReadDataBuf[j++]=temp&0xFF;
		 i++;
		 quantity--;
		}
MODBUS->RESPONSE_FRAME[BYTE_COUNT_FIELD]=coil_quantity*2;
for	(i=0;i<MODBUS->RESPONSE_FRAME[BYTE_COUNT_FIELD];i++)
	{
	 MODBUS->RESPONSE_FRAME[DATA_FIELD+1+i]=MODBUS->ReadDataBuf[i];
	} 
MODBUS->Transmit_data_lenght=3+MODBUS->RESPONSE_FRAME[BYTE_COUNT_FIELD];//0x3a+DEVICE_ID+FUNCTION+byte count+N
}
