#include "stm32f10x.h"
#include "stdlib.h"
#include "Panel.h"
#include "IDMap.h"
#include "GraphInterface.h"
//#include "PanelGlobalVars.h"
/*==================================================================================================================*/
void	WriteDataToHR	(void)	  								//       Modbus
{
	uint8_t i, j;
	
	HoldingRegister[MODBUS_ADDRESS]=MODBUS1.Device_addr;
	HoldingRegister[MODBUS_BOUDRATE]=MODBUS1_SPEED;
	
	HoldingRegister[ADC_MODE_REG]=dADC1.ADCMode;
	HoldingRegister[ADC_CNG_REG]=dADC1.ADCConfig;
	
	
	HoldingRegister[ADC_CODE_PT1]=dADC1.ADCCalib.BaseValuePt[0];
	HoldingRegister[ADC_CODE_PT2]=dADC1.ADCCalib.BaseValuePt[1];
	HoldingRegister[ADC_VOLTAGE_PT1]=dADC1.ADCCalib.ConvValuePt[0];
	HoldingRegister[ADC_VOLTAGE_PT2]=dADC1.ADCCalib.ConvValuePt[1];
	
	if (((HoldingRegister[ADC_CODE_PT1]==0)&&(HoldingRegister[ADC_CODE_PT2]==0))||(HoldingRegister[ADC_VOLTAGE_PT1]==0)&&(HoldingRegister[ADC_VOLTAGE_PT2]==0))
			HoldingRegister[ADC_CALIB_DEFAULT]=0xffff;
			else
					HoldingRegister[ADC_CALIB_DEFAULT]=0;

	HoldingRegister[DAC1_CNG_REG]=dDAC1.DACConfig;
	HoldingRegister[DAC2_CNG_REG]=dDAC2.DACConfig;
	HoldingRegister[DAC1_CODE_PT1]=dDAC1.DACCalib.BaseValuePt[0];
	HoldingRegister[DAC1_CODE_PT2]=dDAC1.DACCalib.BaseValuePt[1];		
	HoldingRegister[DAC1_VAL_PT1]=dDAC1.DACCalib.ConvValuePt[0];
	HoldingRegister[DAC1_VAL_PT2]=dDAC1.DACCalib.ConvValuePt[1];	
	HoldingRegister[DAC2_CODE_PT1]=dDAC2.DACCalib.BaseValuePt[0];
	HoldingRegister[DAC2_CODE_PT2]=dDAC2.DACCalib.BaseValuePt[1];		
	HoldingRegister[DAC2_VAL_PT1]=dDAC2.DACCalib.ConvValuePt[0];
	HoldingRegister[DAC2_VAL_PT2]=dDAC2.DACCalib.ConvValuePt[1];		
	
	if (((HoldingRegister[DAC1_CODE_PT1]==0)&&(HoldingRegister[DAC1_CODE_PT2]==0)&&(HoldingRegister[DAC2_CODE_PT1]==0)&&(HoldingRegister[DAC2_CODE_PT2]==0))||	\
	(HoldingRegister[DAC1_VAL_PT1]==0)&&(HoldingRegister[DAC1_VAL_PT2])&&(HoldingRegister[DAC2_VAL_PT1])&&(HoldingRegister[DAC2_VAL_PT2]))	
			HoldingRegister[DAC_CNG_DEFAULT]=0xffff;	
			else
					HoldingRegister[DAC_CNG_DEFAULT]=0;

//        RADAR II
	HoldingRegister[SS_TYPE]=Sensors.AutoSpeedSensor.Calib.Type;
	if (HoldingRegister[SS_TYPE]==0)		
		{
			HoldingRegister[SS_FREQ_PT1]=Sensors.AutoSpeedSensor.Calib.BaseValuePt[0];
			HoldingRegister[SS_FREQ_PT2]=Sensors.AutoSpeedSensor.Calib.BaseValuePt[1];
			HoldingRegister[SS_SPEED_PT1]=Sensors.AutoSpeedSensor.Calib.ConvValuePt[0];
			HoldingRegister[SS_SPEED_PT2]=Sensors.AutoSpeedSensor.Calib.ConvValuePt[1];
		}
	//     
	HoldingRegister[PS_VALUE_PT1]=Sensors.PumpSpeedSensor.Calib.BaseValuePt[0];
	HoldingRegister[PS_VALUE_PT2]=Sensors.PumpSpeedSensor.Calib.BaseValuePt[1];
	HoldingRegister[PS_SPEED_PT1]=Sensors.PumpSpeedSensor.Calib.ConvValuePt[0];
	HoldingRegister[PS_SPEED_PT2]=Sensors.PumpSpeedSensor.Calib.ConvValuePt[1];

//     
	HoldingRegister[P_VALUE_PT1]=Sensors.PressureSensor.Calib.BaseValuePt[0];
	HoldingRegister[P_VALUE_PT2]=Sensors.PressureSensor.Calib.BaseValuePt[1];
	HoldingRegister[P_PRESSURE_PT1]=Sensors.PressureSensor.Calib.ConvValuePt[0];
	HoldingRegister[P_PRESSURE_PT2]=Sensors.PressureSensor.Calib.ConvValuePt[1];
//34		
//     ()
	HoldingRegister[LS_VALUE3_PT1]=Sensors.LevelSensor3.Calib.BaseValuePt[0];
	HoldingRegister[LS_VALUE3_PT2]=Sensors.LevelSensor3.Calib.BaseValuePt[1];
	HoldingRegister[LS_LEVEL3_PT1]=Sensors.LevelSensor3.Calib.ConvValuePt[0];
	HoldingRegister[LS_LEVEL3_PT2]=Sensors.LevelSensor3.Calib.ConvValuePt[1];

//    peredney stenki
	HoldingRegister[LS_VALUE1_PT1]=Sensors.LevelSensor1.Calib.BaseValuePt[0];
	HoldingRegister[LS_VALUE1_PT2]=Sensors.LevelSensor1.Calib.BaseValuePt[1];
	HoldingRegister[LS_PRESSURE1_PT1]=Sensors.LevelSensor1.Calib.BaseValuePt[2];
	HoldingRegister[LS_PRESSURE1_PT2]=Sensors.LevelSensor1.Calib.BaseValuePt[3];
	HoldingRegister[LS_LEVEL1_PT1]=Sensors.LevelSensor1.Calib.ConvValuePt[0];
	HoldingRegister[LS_LEVEL1_PT2]=Sensors.LevelSensor1.Calib.ConvValuePt[1];
//    zadney stenki	
	HoldingRegister[LS_VALUE2_PT1]=Sensors.LevelSensor2.Calib.BaseValuePt[0];
	HoldingRegister[LS_VALUE2_PT2]=Sensors.LevelSensor2.Calib.BaseValuePt[1];
	HoldingRegister[LS_PRESSURE2_PT1]=Sensors.LevelSensor1.Calib.BaseValuePt[2];
	HoldingRegister[LS_PRESSURE2_PT2]=Sensors.LevelSensor1.Calib.BaseValuePt[3];
	HoldingRegister[LS_LEVEL2_PT1]=Sensors.LevelSensor2.Calib.ConvValuePt[0];
	HoldingRegister[LS_LEVEL2_PT2]=Sensors.LevelSensor2.Calib.ConvValuePt[1];	
//50	
	HoldingRegister[VOLUME_RATE]=SystemBoardConfig.VolumeRate*100;

//   
	HoldingRegister[TS_VALUE_PT1]=Sensors.TempSensor.Calib.BaseValuePt[0];
	HoldingRegister[TS_VALUE_PT2]=Sensors.TempSensor.Calib.BaseValuePt[1];
	HoldingRegister[TS_TEMP_PT1]=Sensors.TempSensor.Calib.ConvValuePt[0];
	HoldingRegister[TS_TEMP_PT2]=Sensors.TempSensor.Calib.ConvValuePt[1];
	

//    ()
	HoldingRegister[PUMP_VALUE_PT1]=Actuators.Pump.Calib.BaseValuePt[0];
	HoldingRegister[PUMP_VALUE_PT2]=Actuators.Pump.Calib.BaseValuePt[1];
	HoldingRegister[PUMP_VALUE_PT3]=Actuators.Pump.Calib.BaseValuePt[2];
	HoldingRegister[PUMP_VALUE_PT4]=Actuators.Pump.Calib.BaseValuePt[3];
	HoldingRegister[PUMP_VALUE_PT5]=Actuators.Pump.Calib.BaseValuePt[4];
//60
	HoldingRegister[PUMP_SPEED_PT1]=Actuators.Pump.Calib.ConvValuePt[0];
	HoldingRegister[PUMP_SPEED_PT2]=Actuators.Pump.Calib.ConvValuePt[1];
	HoldingRegister[PUMP_SPEED_PT3]=Actuators.Pump.Calib.ConvValuePt[2];
	HoldingRegister[PUMP_SPEED_PT4]=Actuators.Pump.Calib.ConvValuePt[3];
	HoldingRegister[PUMP_SPEED_PT5]=Actuators.Pump.Calib.ConvValuePt[4];

	HoldingRegister[PUMP_PROD_PT1]=Actuators.Pump.Calib1.ConvValuePt[0];
	HoldingRegister[PUMP_PROD_PT2]=Actuators.Pump.Calib1.ConvValuePt[1];
	HoldingRegister[PUMP_PROD_PT3]=Actuators.Pump.Calib1.ConvValuePt[2];
	HoldingRegister[PUMP_PROD_PT4]=Actuators.Pump.Calib1.ConvValuePt[3];
	HoldingRegister[PUMP_PROD_PT5]=Actuators.Pump.Calib1.ConvValuePt[4];


	HoldingRegister[PUMP_SPEED_RATE]=Actuators.Pump.PumpSpeedRate;
	HoldingRegister[PUMP_PROD_RATE]=Actuators.Pump.PumpProdRate;			
	//72
	HoldingRegister[REC_MATER_FRATE_REG]=(SystemBoardConfig.Receipt.Material<<8)|SystemBoardConfig.Receipt.Unit;
	HoldingRegister[F_RATE_VALUE]=SystemBoardConfig.Receipt.nFillingRate*100;
	HoldingRegister[REC_INJECT_LEFT]=SystemBoardConfig.Receipt.InjectConfig;	
	HoldingRegister[REC_INJECT_RIGHT]=(uint16_t)SystemBoardConfig.Receipt.InjectConfig>>16;
	HoldingRegister[MIN_TEMP_BURN_REG]=SystemBoardConfig.MinBurnTemperature;
	HoldingRegister[MAX_TEMP_BURN_REG]=SystemBoardConfig.MaxBurnTemperature;	
	HoldingRegister[MIN_BITUM_TEMP_REG]=SystemBoardConfig.MinBitumTemp;			
	HoldingRegister[MAX_BITUM_TEMP_REG]=SystemBoardConfig.MaxBitumTemp;		 
	HoldingRegister[MIN_BITUM_LEVEL_REG]=SystemBoardConfig.MinBitumLevel;			
	HoldingRegister[MAX_BITUM_LEVEL_REG]=SystemBoardConfig.MaxBitumLevel;		
	HoldingRegister[MIN_AUTO_SPEED_REG]=SystemBoardConfig.MinAutoSpeed;		
	HoldingRegister[MAX_AUTO_SPEED_REG]=SystemBoardConfig.MaxAutoSpeed;		 
	HoldingRegister[INJECT_WIDTH]=Actuators.Injects.InjectWidth*100;			  

	HoldingRegister[N_RECEIPT]=SystemBoardConfig.Receipt.nReceipt;
	HoldingRegister[F_RATE_VALUE_MANUAL]=Controls.FRate;	
//     
	HoldingRegister[TC_MODE_REG]=Controls.TCMode;
	HoldingRegister[PUMP_SPEED_MANUAL]=Controls.PumpSpeedManual;
	HoldingRegister[MATER_FRATE_REG]=(Controls.Material<<8)|(Controls.Unit);
	HoldingRegister[CALIBRATE_COMMAND]=CommandCode;
	HoldingRegister[INJECT_CNG_LEFT]	=(uint16_t)Controls.Injects;
	HoldingRegister[INJECT_CNG_RIGHT]	=Controls.Injects>>16;
}
/*==================================================================================================================*/
void	LoadHRTestData	(void)
{
   TestParams.DiscreteInputs			=HoldingRegister[DISCRETE_INPUTS];
   TestParams.BitumTemp					=HoldingRegister[S_TEMP_CURRENT];
   TestParams.BitumLevel1				=HoldingRegister[S_LEVEL1_CURRENT];
   TestParams.BitumLevel2				=HoldingRegister[S_LEVEL2_CURRENT];
   TestParams.PumpPressure				=HoldingRegister[PUMP_PRESSURE];
   TestParams.PumpSpeed					=HoldingRegister[PUMP_SPEED_CURRENT];
   TestParams.AutoSpeed					=HoldingRegister[AUTOSPEED];	
}
/*==================================================================================================================*/
void HRSet	(MODBUS_DATA *MODBUS,USART_TypeDef *USARTx)	   //  ,    
{
uint8_t i,j=0;
	
	DiscreteInputs							=HoldingRegister[DISCRETE_INPUTS];
	Sensors.PneumoPressureSensor=DiscreteInputs&&PNEUMO_PRESSUE_NORMA;		//  () 
	Sensors.BitumPressureSensor	=DiscreteInputs&&BITUM_PRESSUE_NORMA;			//  ()   
	Sensors.DirtyFilterSensor		=DiscreteInputs&&DIRTY_FILTER;							//  
	Sensors.Filling							=DiscreteInputs&&FILLING_ON;													//  
	Sensors.Heating							=DiscreteInputs&&HEATING_ON;													// 
	Sensors.AutoSpeedPrs				=DiscreteInputs&&AUTO_SPEED_PRESSENCE;						//   
	Sensors.LevelAlarm					=DiscreteInputs&&LEVEL_ALARM;				
	
for (i=ADC_VOLTAGE_1_2; i<=ADC_VOLTAGE_7_8;i++)
		{
		 dADC1.ADCBuffer[j++]			=(((HoldingRegister[i])<<8)>>8)*10;
		 dADC1.ADCBuffer[j++]			=((HoldingRegister[i])>>8)*10;
		}
j=0;		
for (i=ADC_CODE_1;i<=ADC_CODE_8;i++)
		{
			dADC1.ADC_Codes[j]						=HoldingRegister[i];
			j++;
		}
dDAC1.DACVoltage										=HoldingRegister[DAC1_CURRENT_VAL];
dDAC2.DACVoltage										=HoldingRegister[DAC2_CURRENT_VAL];
		
Sensors.AutoSpeedSensor.BaseValue		=HoldingRegister[SS_FREQ_CURRENT]*100;
Sensors.AutoSpeedSensor.CurrentValue=HoldingRegister[AUTOSPEED]*100;
Sensors.PumpSpeedSensor.CurrentValue=HoldingRegister[PUMP_SPEED_CURRENT];	
Sensors.PressureSensor.CurrentValue	=HoldingRegister[PUMP_PRESSURE];
Sensors.TempSensor.CurrentValue			=HoldingRegister[S_TEMP_CURRENT];
Sensors.LevelSensor1.CurrentValue		=HoldingRegister[S_LEVEL1_CURRENT];
Sensors.LevelSensor2.CurrentValue		=HoldingRegister[S_LEVEL2_CURRENT];
Sensors.LevelSensor3.CurrentValue		=HoldingRegister[S_LEVEL3_CURRENT];
Sensors.LevelSensor1.BaseValue			=HoldingRegister[S_PRESSURE1_CURRENT];
Sensors.LevelSensor2.BaseValue			=HoldingRegister[S_PRESSURE2_CURRENT];		
	
ComputedParams.DistanceGone					=HoldingRegister[DISTANCE_FILL_REG];
ComputedParams.TimeGone							=HoldingRegister[DISTTIME_FILL_REG];
ComputedParams.MixtureVolumeIn			=HoldingRegister[CURRENT_TANK_VOL_REG];
ComputedParams.MixtureVolumeOut			=HoldingRegister[USED_TANK_VOL_REG];
ComputedParams.SquareFilled					=HoldingRegister[SQUARE_FILL_REG];
ComputedParams.FillingWidth					=HoldingRegister[FILLING_WIDTH];		
Actuators.Injects.InjectConfiguration=((HoldingRegister[INJECT_CNG_RIGHT])<<16)|HoldingRegister[INJECT_CNG_LEFT];
CurrentParameters.ErrorMsg					=HoldingRegister[MSG_REG];
Actuators.TCMode										=HoldingRegister[TC_MODE_REG]&3;
Actuators.BitumenBackValve					=((HoldingRegister[TC_MODE_REG])>>2)&1;	
Actuators.HeatingManual							=((HoldingRegister[TC_MODE_REG])>>3)&1;	

CurrentParameters.nFillingRate			=HoldingRegister[F_RATE_VALUE_MANUAL	]*100;
CurrentParameters.Material					=HoldingRegister[MATER_FRATE_REG]>>8;
CurrentParameters.Unit							=HoldingRegister[MATER_FRATE_REG]&0x0F;
}
/*==============================================================================================================*/
void CANSet	(CAN_DATA_STRUCTURE *CAN_LLPx)	   //  ,    
{
static	uint8_t			nPacket=1;
static  uint8_t			nSubPacket=1;
static	uint8_t			Calib=0;

if ((CAN_LLPx->CAN_RspRdy==0)&&(CAN_LLPx->CAN_TxRdy==0)&&(CAN_PACKET))
	{
	 CAN_PACKET=0;
	 switch (nPacket)
	 		{
			  case 1: {
				 		CAN_LLP_DataMaster(CAN_LLPx,CONTROLS_CAN);
						nPacket=2; 
					  } break;
			  case 2: {
				  		if (CommandCode!=0x00)
							{
							  switch(CommandCode)
									 {
										case 0x02: {CAN_LLP_DataMaster(CAN_LLPx,ADC_CNG_CAN);} 	 			break;
					 					case 0x03: {CAN_LLP_DataMaster(CAN_LLPx,DAC1_CNG_CAN);}  	 		break;
		 			 					case 0x04: {CAN_LLP_DataMaster(CAN_LLPx,DAC2_CNG_CAN);} 	 		break;						   
					 					case 0x05: {CAN_LLP_DataMaster(CAN_LLPx,SPEED_SENSOR_CAN);}			break; 						   
					 					case 0x06: {CAN_LLP_DataMaster(CAN_LLPx,PUMP_SPEED_SENSOR_CAN);}	break;								  
					 					case 0x07: {
													CAN_LLP_DataMaster(CAN_LLPx,LEVEL1_SENSOR_CAN);
												   }		break;
										case 0x08: {CAN_LLP_DataMaster(CAN_LLPx,TEMP_SENSOR_CAN);}			break;
					 					case 0x09: {CAN_LLP_DataMaster(CAN_LLPx,PUMP_CONT_CALIB_CAN);Calib++;}break;
					 					case 0x0A: {
														CAN_LLP_DataMaster(CAN_LLPx,TC_PARAMS_CAN);
												   } 		    break;
					 					case 0x0B: {
														CAN_LLP_DataMaster(CAN_LLPx,TC_PARAMS_CAN);
												   } 		    break;
										/*case 0x0C: {
														CAN_LLP_DataMaster(CAN_LLPx,ADD_PARAMS_CAN);
												   }		    break;*/
					 					case 0x0D: {	CAN_LLP_DataMaster(CAN_LLPx,PRESSURE_SENSOR_CAN);}	break;	  				  		
					 					case 0x14: {
														CAN_LLP_DataMaster(CAN_LLPx,RECEIPT_CAN);
												   }			break;
					 					case 0x15: {
														CAN_LLP_DataMaster(CAN_LLPx,RECEIPT_CAN);
												   }			break;
										case 0x16: CAN_LLP_DataMaster(CAN_LLPx,RECEIPT_CAN);				break;
										case 0x17: {CAN_LLP_DataMaster(CAN_LLPx,RECEIPT_CAN);}   			break;	
		 			 				  	case 0xff:	{
													switch (nSubPacket)
															{
															  case	1: {CAN_LLP_DataMaster(CAN_LLPx,ADC_CNG_CAN); nSubPacket=2;}	  	     break;
															  case	2: {CAN_LLP_DataMaster(CAN_LLPx,DAC1_CNG_CAN);nSubPacket=3;}  		 break;
															  case	3: {CAN_LLP_DataMaster(CAN_LLPx,DAC2_CNG_CAN);nSubPacket=4;}  		 break;
															  case	4: {CAN_LLP_DataMaster(CAN_LLPx,SPEED_SENSOR_CAN);nSubPacket=5;}	 break;
															  case	5: {CAN_LLP_DataMaster(CAN_LLPx,PUMP_SPEED_SENSOR_CAN);nSubPacket=6;}break;
															  case  6: {CAN_LLP_DataMaster(CAN_LLPx,LEVEL1_SENSOR_CAN);nSubPacket=7;}	 break;
															  case	7: {CAN_LLP_DataMaster(CAN_LLPx,LEVEL2_SENSOR_CAN);nSubPacket=8;}	 break;
															  case	8: {CAN_LLP_DataMaster(CAN_LLPx,LEVEL3_SENSOR_CAN);nSubPacket=9;}	 break;
															  case  9: {CAN_LLP_DataMaster(CAN_LLPx,TEMP_SENSOR_CAN);nSubPacket=10;}	 break;
															  case	10: {CAN_LLP_DataMaster(CAN_LLPx,PUMP_CONT_CALIB_CAN);nSubPacket=11;}break;
															  case	11: {CAN_LLP_DataMaster(CAN_LLPx,PUMP_CONT_CALIB_CAN);nSubPacket=12;}break;
															  case  12: {CAN_LLP_DataMaster(CAN_LLPx,TC_PARAMS_CAN);nSubPacket=13;}		 break;
															  case	13: {CAN_LLP_DataMaster(CAN_LLPx,PRESSURE_SENSOR_CAN);nSubPacket=14;}break;
															  case  14: {CAN_LLP_DataMaster(CAN_LLPx,INJECT_WIDTH_CAN);nSubPacket=15;}	 break;
														   }
													}					break;
									  }	
							if (CommandCode==0x09)
								{
									if (Calib==2)
										{
											Calib=0;
											CommandCode=0;
										}		
								}
								else
										if ((CommandCode!=0xff)||((CommandCode==0xff)&&(nSubPacket==15)))
											{
								   				CommandCode=0;
								   				nSubPacket=1;
								   				nPacket=3;
											}
							}
							else
								{
								   CAN_LLP_DataMaster(CAN_LLPx,TEST_PARAMS_CAN);
						  		   nPacket=4;
								}
						} break;
			case	3:	{
				  		  CAN_LLP_DataMaster(CAN_LLPx,TEST_PARAMS_CAN);
						  nPacket=4;
				  		} break;
			case  4:	{
				  		  CAN_LLP_DataMaster(CAN_LLPx,GET_ALL_CAN);
						  nPacket=1;
						} break;  
				  default: break;
			}
	}
}


