#include "USART.h"
#include "Modbus_ASCIIGlobalVars.h"
 // USART2							 
/*/===================================================================================================*/
void	Init_USART	(uint32_t USART_SPEED, USART_TypeDef* USART, uint16_t WordLenght)
{
USART_InitTypeDef		USART_InitStructure;  			//   USART_InitTypeDef
USART_InitStructure.USART_BaudRate=USART_SPEED;				//  
USART_InitStructure.USART_HardwareFlowControl=USART_HardwareFlowControl_None; //  
USART_InitStructure.USART_Mode=USART_Mode_Tx|USART_Mode_Rx;			//  
USART_InitStructure.USART_Parity=USART_Parity_No;		 //  
USART_InitStructure.USART_WordLength=WordLenght;	 //  =8 
USART_InitStructure.USART_StopBits=USART_StopBits_1;	//1  
USART_Init(USART,&USART_InitStructure);		 		// 
USART_ClearFlag(USART, USART_FLAG_CTS|USART_FLAG_LBD|USART_FLAG_TC|USART_FLAG_RXNE|USART_FLAG_TXE);
USART_Cmd(USART,ENABLE);  								//  USART2
} 
/*=========================================================================*/
void	USART2_IRQHandler	(void) //!!!
{
if (USART_GetITStatus(USART2,USART_IT_PE))	{Reset_Frame(&MODBUS1);}
if (USART_GetITStatus(USART2, USART_IT_RXNE)==SET)
 	{
	  USART_ClearITPendingBit(USART2, USART_IT_RXNE);
		if (MODBUS2.StateFlags&(1<<MB_RESPONSE_WAIT_FLAG))
				Receive_Quest_Master(&MODBUS2,USART2,MODBUS1_MASTER_TIM);
 	}

if (USART_GetITStatus(USART2,USART_IT_TC)) 
	{
	  USART_ClearITPendingBit(USART2, USART_IT_TC);
		if (MODBUS2.StateFlags&(1<<MB_TRANSMIT_FLAG))
				SendRequest_Master(&MODBUS2, USART2);
	}
}
/*=========================================================================*/
void	USART1_IRQHandler	(void) //!!!
{
if (USART_GetITStatus(USART1,USART_IT_PE))	{Reset_Frame(&MODBUS1);}
if (USART_GetITStatus(USART1, USART_IT_RXNE)==SET)
 	{
	  USART_ClearITPendingBit(USART1, USART_IT_RXNE);
	  if (!(MODBUS1.StateFlags&(1<<MB_TRANSMIT_FLAG)))
	  Receive_Quest(&MODBUS1,USART1);
 	}

if (USART_GetITStatus(USART1,USART_IT_TC)) 
	{
	  USART_ClearITPendingBit(USART1, USART_IT_TC);
	  SendResponse(&MODBUS1, USART1);
	}
}
