#define	MODBUS_ADDRESS			0
#define	MODBUS_BOUDRATE			1

#define	ADC_CALIB_DEFAULT		2
//    	
#define ADC_MODE_REG			3
#define	ADC_CNG_REG				4
#define	ADC_CODE_PT1			5
#define	ADC_CODE_PT2			6
#define	ADC_VOLTAGE_PT1			7
#define	ADC_VOLTAGE_PT2			8
//    
#define	DAC_CNG_DEFAULT			9
#define	DAC1_CNG_REG			10
#define DAC1_CODE_PT1			11
#define DAC1_CODE_PT2			12
#define DAC1_VAL_PT1			13
#define DAC1_VAL_PT2			14
#define	DAC2_CNG_REG			15
#define DAC2_CODE_PT1			16
#define DAC2_CODE_PT2			17
#define DAC2_VAL_PT1			18
#define DAC2_VAL_PT2			19
//        RADAR II
#define SS_FREQ_PT1				20		//      
#define SS_FREQ_PT2				21		//       
#define SS_SPEED_PT1			22		//      
#define SS_SPEED_PT2			23		//      
#define	SS_TYPE					24	    //      /
//     
#define PS_VALUE_PT1			25		//      (  )
#define PS_VALUE_PT2			26		//     (  )
#define PS_SPEED_PT1			27		//        
#define PS_SPEED_PT2			28		//       
//     
#define P_VALUE_PT1				29		//      (  )
#define P_VALUE_PT2				30		//     (  )
#define P_PRESSURE_PT1			31		//       
#define P_PRESSURE_PT2			32		//      
//      
#define LS_VALUE1_PT1			33		//      ( ())	.1
#define LS_VALUE1_PT2			34		//      ( ()).1
#define LS_PRESSURE1_PT1		35		//       
#define LS_PRESSURE1_PT2		36		//       
#define LS_LEVEL1_PT1			37		//      
#define LS_LEVEL1_PT2			38		//      
//     
#define LS_VALUE2_PT1			39		//      ( ())	.2
#define LS_VALUE2_PT2			40		//      ( ()).2
#define LS_PRESSURE2_PT1		41		//       
#define LS_PRESSURE2_PT2		42		//       
#define LS_LEVEL2_PT1			43		//         .2
#define LS_LEVEL2_PT2			44		//        .2
#define	VOLUME_RATE				45
//     ()
#define LS_VALUE3_PT1			46		//      ( ())	.2
#define LS_VALUE3_PT2			47		//      ( ()).2
#define LS_LEVEL3_PT1			48		//         .2
#define LS_LEVEL3_PT2			49		//        .2//   
//   
#define TS_VALUE_PT1			50		//      ( ())	.1
#define TS_VALUE_PT2			51		//      ( ()).1
#define TS_TEMP_PT1				52		//        
#define TS_TEMP_PT2				53		//        
//    ()
#define PUMP_VALUE_PT1			54		//      (  )
#define PUMP_VALUE_PT2			55		//     (  )
#define PUMP_VALUE_PT3			56		//     (  )
#define PUMP_VALUE_PT4			57		//     (  )
#define PUMP_VALUE_PT5			58		//    (  )
#define PUMP_SPEED_PT1			59		//      
#define PUMP_SPEED_PT2			60		//      
#define PUMP_SPEED_PT3			61		//      
#define PUMP_SPEED_PT4			62		//      
#define PUMP_SPEED_PT5			63		//        
#define PUMP_PROD_PT1				64		//      (/)
#define PUMP_PROD_PT2				65		//      (/)
#define PUMP_PROD_PT3				66		//      (/)
#define PUMP_PROD_PT4				67		//      (/)
#define PUMP_PROD_PT5				68		//      (/)
#define PUMP_SPEED_RATE			69		//    
#define PUMP_PROD_RATE			70		//    
//=============================================================================================================
//      
#define REC_MATER_FRATE_REG	 	71  	//  (0 )/  ( )(1 )
#define F_RATE_VALUE		 			72		//  ()
#define REC_INJECT_LEFT				73		//   
#define REC_INJECT_RIGHT			74		//   
#define MIN_TEMP_BURN_REG	 		75		//  
#define MAX_TEMP_BURN_REG			76		//  
#define MIN_BITUM_TEMP_REG		77      //  
#define MAX_BITUM_TEMP_REG	 	78  	//  
#define MIN_BITUM_LEVEL_REG		79		//    
#define MAX_BITUM_LEVEL_REG		80		//    
#define MIN_AUTO_SPEED_REG	 	81		//   
#define MAX_AUTO_SPEED_REG	 	82		//   
#define INJECT_WIDTH		  		83		//  1 
//=============================================================================================================
//     
#define CALIBRATE_COMMAND			84

#define TC_MODE_REG						85     //    
#define PUMP_SPEED_MANUAL			86		//    
#define	MATER_FRATE_REG	    	87
#define N_RECEIPT							88     // 
#define F_RATE_VALUE_MANUAL	 	89		//  ()     
#define INJECT_CNG_LEFT				90		//  
#define INJECT_CNG_RIGHT			91		//  


//=============================================================================================================
//  
#define	ADC_CODE_1					92
#define	ADC_CODE_2					93
#define	ADC_CODE_3					94
#define	ADC_CODE_4					95
#define	ADC_CODE_5					96
#define	ADC_CODE_6					97
#define	ADC_CODE_7					98
#define	ADC_CODE_8					99
#define	ADC_VOLTAGE_1_2			100
#define	ADC_VOLTAGE_3_4			101
#define	ADC_VOLTAGE_5_6			102
#define	ADC_VOLTAGE_7_8			103

#define	DAC1_CURRENT_VAL		104
#define	DAC2_CURRENT_VAL		105

// 
#define	DISCRETE_INPUTS			106
#define SS_FREQ_CURRENT			107		//    avto
#define AUTOSPEED						108		//  
// ( )
#define PUMP_SPEED_CURRENT	109		//   
//   
#define PUMP_PRESSURE				110		//   
// 	1
#define S_LEVEL1_CURRENT		111		//    1
#define S_LEVEL2_CURRENT		112		//    2
#define S_LEVEL3_CURRENT		113		//    3
#define S_PRESSURE1_CURRENT	114		//    1
#define S_PRESSURE2_CURRENT	115		//    2
// 
#define S_TEMP_CURRENT			116		//   
// 
#define DISTANCE_FILL_REG	 		117		// 
#define DISTTIME_FILL_REG	 		118		// 
#define SQUARE_FILL_REG	 			119		// 
#define CURRENT_TANK_VOL_REG	120		//    
#define USED_TANK_VOL_REG  		121		//    
#define FILLING_WIDTH	  			122		// 
#define MSG_REG				  			123		//      



 //Defibitiopns for HR Registers map in flash
#define	F_MODBUS_ADDRESS		0
#define	F_MODBUS_BOUDRATE		1
#define	F_ADC_MODE_REG		 	2 
#define	F_ADC_CNG_REG			3
#define	F_K_ADC					4
#define	F_B_ADC					5
#define	F_DAC1_CNG_REG			6 
#define F_K_DAC1				7
#define F_B_DAC1				8 
#define	F_DAC2_CNG_REG			9
#define F_K_DAC2				10
#define F_B_DAC2				11

#define F_K_SS					12	// K     
#define F_B_SS					13	// B	     
#define	F_SS_TYPE				14

#define F_K_PS					15	// K1     	 
#define F_B_PS					16	// B1     	 

#define F_K_P					17	// K1     	 
#define F_B_P					18	// B1     	 


#define F_K_LS1					19	// K      1
#define F_B_LS1					20	// B	      1
#define F_K_LPS1				21	// K      1
#define F_B_LPS1				22	// B	      1

#define F_K_LS2					23	// K      2
#define F_B_LS2					24	// B	      2
#define F_K_LPS2				25	// K      2
#define F_B_LPS2				26	// B	      2

#define F_K_LS3					27	// K      3
#define F_B_LS3					28	// B	      3
#define F_K_LPS3				29	// K      3
#define F_B_LPS3				30	// B	      23

#define F_K_TS					31	// K     
#define F_B_TS					32	// B	     
//      ( -)
#define F_K1_PUMP				33	// K1      
#define F_K2_PUMP				34	// K2      
#define F_K3_PUMP				35	// K3      
#define F_K4_PUMP				36	// K4      
#define F_B1_PUMP				37	// B1      
#define F_B2_PUMP				38	// B2      
#define F_B3_PUMP				39	// B3      
#define F_B4_PUMP				40	// B4      
#define F_PUMP_XPOINT1			41	//    
#define F_PUMP_XPOINT2			42	//    
#define F_PUMP_XPOINT3			43	//    
#define F_PUMP_XPOINT4			44	//    
//    ( -)
#define F_K1_PUMP_PROD			45	// K1      
#define F_K2_PUMP_PROD			46	// K2      
#define F_K3_PUMP_PROD			47	// K3      
#define F_K4_PUMP_PROD			48	// K4      
#define F_B1_PUMP_PROD			49	// B1      
#define F_B2_PUMP_PROD			50	// B2      
#define F_B3_PUMP_PROD			51	// B3      
#define F_B4_PUMP_PROD			52	// B4      
#define F_PUMP_XPOINT1_PROD		53	//    
#define F_PUMP_XPOINT2_PROD		54	//    
#define F_PUMP_XPOINT3_PROD		55	//    
#define F_PUMP_XPOINT4_PROD		56	//    


#define F_MIN_TEMP_BURN_REG	 	57		//  
#define F_MAX_TEMP_BURN_REG		58		//  
#define F_MIN_BITUM_TEMP_REG	59      //  
#define F_MAX_BITUM_TEMP_REG	60 	    //  
#define F_MIN_BITUM_LEVEL_REG	61		//    
#define F_MAX_BITUM_LEVEL_REG	62		//    
#define F_MIN_AUTO_SPEED_REG	63		//   
#define F_MAX_AUTO_SPEED_REG	64		//   
#define F_INJECT_WIDTH		  	65		//  1 
#define	F_K_RATE_PUMP			66

#define F_MATERIAL				67	   //      0-, 1 - 
#define F_FRATE					68	   //        0-/2, 1 - /2
#define F_F_RATE_VALUE1			69	   //    *10   1	  1 
#define F_F_RATE_VALUE2			70	   //    *10   2
#define F_F_RATE_VALUE3			71	   //    *10   3
#define F_F_RATE_VALUE4			72	   //    *10   4
#define F_F_RATE_VALUE5			73	   //    *10   5
#define F_F_RATE_VALUE6			74	   //    *10   6
#define F_F_RATE_VALUE7			75	   //    *10   7
#define F_F_RATE_VALUE8			76	   //    *10   8
#define F_F_RATE_VALUE9			77	   //    *10   9
#define F_F_RATE_VALUE10		78	   //    *10   10
#define F_F_RATE_VALUE11		79	   //    *10   11
#define F_F_RATE_VALUE12		80	   //    *10   12
#define F_F_RATE_VALUE13		81	   //    *10   13
#define F_F_RATE_VALUE14		82	   //    *10   14
#define F_F_RATE_VALUE15		83	   //    *10   15
#define F_F_RATE_VALUE16		84	   //    *10   16

#define F_INJECT_LEFT1			85	   //      1
#define F_INJECT_RIGHT1			86	   //      1
#define F_INJECT_LEFT2			87	   //      2
#define F_INJECT_RIGHT2			88	   //      2
#define F_INJECT_LEFT3			89	   //      3
#define F_INJECT_RIGHT3			90	   //      3
#define F_INJECT_LEFT4			91	   //      4
#define F_INJECT_RIGHT4			92	   //      4
#define F_INJECT_LEFT5			93	   //      5
#define F_INJECT_RIGHT5			94	   //      5
#define F_INJECT_LEFT6			95	   //      6
#define F_INJECT_RIGHT6			96	   //      6
#define F_INJECT_LEFT7			97	   //      7
#define F_INJECT_RIGHT7			98	   //      7
#define F_INJECT_LEFT8			99	   //      8
#define F_INJECT_RIGHT8			100	   //      8
#define F_INJECT_LEFT9			101	   //      9
#define F_INJECT_RIGHT9			102	   //      9
#define F_INJECT_LEFT10			103	   //      10
#define F_INJECT_RIGHT10		104	   //      10
#define F_INJECT_LEFT11			105	   //      11
#define F_INJECT_RIGHT11		106	   //      11
#define F_INJECT_LEFT12			107	   //      12
#define F_INJECT_RIGHT12		108	   //      12
#define F_INJECT_LEFT13			109	   //      13
#define F_INJECT_RIGHT13		110	   //      13
#define F_INJECT_LEFT14			111	   //      14
#define F_INJECT_RIGHT14		112	   //      14
#define F_INJECT_LEFT15			113	   //      15
#define F_INJECT_RIGHT15		114	   //      15
#define F_INJECT_LEFT16			115	   //      16
#define F_INJECT_RIGHT16		116	   //      16

#define F_RECEIPT_AMOUNT		117	   //   
#define	F_HR_QUANTITY			118

