#include 	"stm32f10x.h"
#include 	"Modbus_ASCIIGlobalVars.h"
#include	"ModbusMaster_protocol.h"
//(10)//======================================================================================!!!!
void	Reset_Frame_Master	(MODBUS_DATA *MODBUS,TIM_TypeDef *TIMx)	//  
{
  MODBUS->StateFlags&=~(1<<MB_RECEIVE_FLAG);  //not address id				  //   
  MODBUS->StateFlags&=~(1<<MB_TRANSMIT_FLAG);
  MODBUS->ind_rx=0;
  MODBUS->ind_tx=0;
  MODBUS->Received_Frame_Lenght=0;
  MODBUS->subbyte=0;
  MODBUS->Transmit_data_lenght=0;
  MODBUS->StateFlags&=~(1<<MB_RCF_FLAG);
  MODBUS->StateFlags&=~(1<<MB_TRS_FLAG);
  MODBUS->StateFlags&=~(1<<MB_REQUEST_READY_FLAG);
	//MODBUS->StateFlags&=~(1<<MB_RESPONSE_READY_FLAG);
	MODBUS->StateFlags&=~(1<<MB_RESPONSE_WAIT_FLAG);
  TmrOff(TIMx);
}
////======================================================================================!!!!
void	TranshipmentFrame	(MODBUS_DATA *MODBUS)	//  
{
  MODBUS->StateFlags&=~(1<<MB_RECEIVE_FLAG);  //not address id				  //   
  MODBUS->StateFlags&=~(1<<MB_TRANSMIT_FLAG);
  MODBUS->ind_rx=0;
  MODBUS->ind_tx=0;
  MODBUS->subbyte=0;
  MODBUS->StateFlags&=~(1<<MB_RCF_FLAG);
  MODBUS->StateFlags&=~(1<<MB_TRS_FLAG);
  MODBUS->StateFlags|=1<<MB_REQUEST_READY_FLAG;
	MODBUS->StateFlags&=~(1<<MB_RESPONSE_WAIT_FLAG);
}
///(11)
////(6)===================================================!!!!!!,        
void	Receive_Quest_Master	(MODBUS_DATA *MODBUS,USART_TypeDef *USARTx,TIM_TypeDef *TIMx)
{
static	unsigned	char	pred_char=0;
		unsigned	char	temp_buf;
		unsigned	char	temp_var;

if (MODBUS->ind_rx<MAX_FRAME_LENGHT) //      256
	{
 	temp_buf=USARTx->DR ;		 // 
	if	(!(MODBUS->StateFlags&(1<<MB_RECEIVE_FLAG)))					 //    
 		 {
	 	  if (temp_buf==0x3A)				 //.        
 			  {
		 	  MODBUS->StateFlags|=1<<MB_RECEIVE_FLAG;				 //  -    
		 	  MODBUS->ind_rx=0;							 // MODBUS1.ind_rx
			  //Timer_OFF(TIMx);
			  } 
		 }
 	 else		//if receiving frame  		//   
 		  {
		  //
		  if	((temp_buf==0x0A)&&(pred_char==0x0D))			   //,        
		         {
		   		 MODBUS->StateFlags&=~(1<<MB_RECEIVE_FLAG);	  							  // ,     	
			  	 MODBUS->Received_Frame_Lenght=MODBUS->Received_Frame_Lenght;	  				 //   = + + +LRC	
			  	 MODBUS->StateFlags|=1<<MB_RCF_FLAG;	 								//	    							
				 //Timer_OFF(TIMx);
				 }
			else   												//     
				{
			     temp_var=ASCII_to_Hex(temp_buf,MODBUS);								//       16-
				 if(!(MODBUS->subbyte))		  							//   - (ASCII_to_Hex  subbyte=0)
				 	{
			 		if	((MODBUS->ind_rx==0)&&(temp_var!=MODBUS->Device_addr))   //        ( )    
						{
				  		 Reset_Frame_Master(MODBUS,TIMx);	   								//      .        
						}
			   		else   											//              
			 			{	  
			  	 		MODBUS->RESPONSE_FRAME[MODBUS->ind_rx++]=temp_var;	   				//    
			 	 		MODBUS->Received_Frame_Lenght++;								//  
						}
					}		//       	
				 }
		  }
	//Timer_ON(TIMx);
  	pred_char=temp_buf;
	}
 else Reset_Frame_Master(MODBUS,TIMx);//	      256  -  
}
//(=====================================================================================  !!!!!
int	Check_LRC_Master	(MODBUS_DATA *MODBUS)	  //return 0 if NO LRC eroor; return 1 if LRC error is
///==================================================================================================
{
unsigned	char	i=0;
unsigned	char	LRC_count=0;

   for (i=0;i<(MODBUS->Received_Frame_Lenght-1);i++)
   		{
		 LRC_count=LRC_count+MODBUS->RESPONSE_FRAME[i];	 //       LRC
		}
   LRC_count=0xFF-(unsigned char)LRC_count+1; 	// 	 LRC_count
   if	(MODBUS->RESPONSE_FRAME[MODBUS->Received_Frame_Lenght-1]!=LRC_count)
   		return	1;	 //    LRC        1
	else	return 0;  //    0
}
//(15)
//====================================================================================
void	ClearResponseBuf	(MODBUS_DATA *MODBUS)
{
unsigned char	i=0;
for (i=0;i<MODBUS->Received_Frame_Lenght;i++)
	{MODBUS->RESPONSE_FRAME[i]=0;}
}
//(16_2)======================================================================================
void	ClearModbusBuf	(MODBUS_DATA *MODBUS)
{
unsigned char	i=0;
for (i=0;i<MODBUS->Transmit_data_lenght;i++)
	{MODBUS->MODBUS_FRAME[i]=0;}
}
//(16)
/*============================================================================================*/
void	SendRequest_Master	(MODBUS_DATA *MODBUS,USART_TypeDef *USARTx)
{
	if (MODBUS->ind_tx<MODBUS->Transmit_data_lenght)
			{
			USARTx->DR=Hex_to_ASCII(MODBUS->MODBUS_FRAME[MODBUS->ind_tx],MODBUS);
			}
		else 
			{
			MODBUS->StateFlags|=1<<MB_TRS_FLAG;
			}
}
//(20)=====================================================count LRC for request!!!!
unsigned	char	CountRequestLRC_Master	(uint8_t a, MODBUS_DATA *MODBUS)
{
uint8_t	i;
uint8_t	b=0;
 for  (i=DEVICE_ID_FIELD;i<a;i++)
 	{
	 b=b+MODBUS->MODBUS_FRAME[i];
	}
b=0xFF-b+1;
return	b;
}
/*============================================================================*/
void	FormFrameStartEnd_Master	(uint8_t slave_id, uint8_t func, MODBUS_DATA *MODBUS)
{
MODBUS->MODBUS_FRAME[DEVICE_ID_FIELD]=slave_id;
MODBUS->MODBUS_FRAME[FUNCTION_CODE_FIELD]=func;
MODBUS->MODBUS_FRAME[MODBUS->Transmit_data_lenght]=CountRequestLRC_Master(MODBUS->Transmit_data_lenght,MODBUS);  //
MODBUS->MODBUS_FRAME[++MODBUS->Transmit_data_lenght]=0x0d;  //13=0x0d;
MODBUS->MODBUS_FRAME[++MODBUS->Transmit_data_lenght]=0x0a;  //10=0x0a;
MODBUS->Transmit_data_lenght++;
MODBUS->StateFlags|=1<<MB_REQUEST_READY_FLAG;
}