//Limits for registers
#define MIN_QUANTITY 0x01
#define MAX_QUANTITY 0x007D//125   
//Define maximum MODBUS frame lenght
#define MAX_FRAME_LENGHT 256
//Define array for of MAX_FRAME_LENGHT bytes for Modbus receive frame
//unsigned	char	MODBUS_FRAME[MAX_FRAME_LENGHT];
//Define array for of MAX_FRAME_LENGHT bytes for Modbus response frame
//unsigned	char	RESPONSE_FRAME[MAX_FRAME_LENGHT];
//Definitions  for modbus frame fields
#define		DEVICE_ID_FIELD					(uint8_t)				0
#define		FUNCTION_CODE_FIELD			(uint8_t)				1
#define		DATA_FIELD							(uint8_t)				2
#define		BYTE_COUNT_FIELD				(uint8_t)				2
#define		SIMPLE_DATA_LENGHT			(unsigned char)	6

//MODBUS FLAGS BITS
#define			MB_RECEIVE_FLAG					0 	//receiving flag
#define			MB_TRANSMIT_FLAG				1		//receiving flag
#define			MB_RCF_FLAG							2	  //frame received flag
#define			MB_TRS_FLAG							3  	//frame sending flag
#define			MB_RESPONSE_READY_FLAG	4
#define			MB_REQUEST_READY_FLAG		5
#define 		MB_RESPONSE_WAIT_FLAG		6		//ojidanie otveta ot ustroistva	
#define			NO_CONNECT_FLAG					7

#define		MODBUS_SPEED			115200
#define		MODBUS_USART_Pins	GPIO_Pin_2, GPIO_Pin_3, GPIOA
#define		MODBUS_USART			USART2
#define		MODBUS_Interrupt	USART2_IRQn

#define		MODBUS1_SPEED		115200
#define		MODBUS2_SPEED		115200	
#define		MODBUS1_USART_Pins	GPIO_Pin_9, GPIO_Pin_10,GPIO_Pin_8, GPIOA
#define		MODBUS2_USART_Pins	GPIO_Pin_5, GPIO_Pin_6, 0,          GPIOD

#define		MODBUS1_USART		USART1
#define		MODBUS2_USART		USART2
#define		MODBUS1_Interrupt	USART1_IRQn
#define		MODBUS2_Interrupt	USART2_IRQn
#define		MODBUS1_PRIORITY	0
#define		MODBUS2_PRIORITY	0
#define		MODBUS1_Remap		0
#define		MODBUS2_Remap		GPIO_Remap_USART2 
#define		RS_485				USART1
#define		RS_232				USART2
#define		MODBUS1_MASTER_TIM	TIM7
#define		MODBUS_MASTER		1
#define		MODBUS_SLAVE		2
#define		MODBUS1_MASTER_TIM_IRQ	TIM7_IRQn

#define		EnableRS_485Transmitter		GPIOA->ODR|=1<<8		//set CS - disable receiver, enable transmitter
#define		DisableRS_485Transmitter	GPIOA->ODR&=~(1<<8)     //reset CS - enable receiver, disable transmitter


#define		RESPONSEOK			0
#define		LRCERR					1
#define		EXCERR1					2
#define		EXCERR2					3
#define		EXCERR3					4
#define		EXCERR4					5
#define		EXCERR5					6
#define		TIMEOUT_ERROR		7		//?