#include  "stm32f10x.h"
#include	"MyMath.h"
/*=============================================================================================*/
double my_sqrt(double x) 									//    
{
float eps=0.000001; 
float y;
float z;

if (x<0) return 0;
    y=1.0;
   //{ while    . ,   
    //    }
    while (Module(z-y)>=eps)
    	 { 
        	z=y; 
        	y=(y+x/y)/2;
		 }
return y; 
}
/*========================================================================================================================================================*/
float Module (float x)									   //   
{
if (x<0) 
	x=-x;
return x;
}
/*========================================================================================================================================================*/
float ArcSin(float x)									  //   .    - 
{
float AsinVal;
float argsq=0;
if (x==1)   
   AsinVal=1.57;
   else 
       if (x==-1) 
	  AsinVal=-1.57;
        else
            {
			 argsq=my_sqrt(1-(x*x));
             AsinVal=ArcTan(x/(argsq));
            }
return AsinVal;
}
/*========================================================================================================================================================*/
float ArcTan (float x)									  //   . .  . - -  .
{

if ((x>=1)||(x<=-1))
	{
	 return 1.57*Signat(x)-(32*(1.0/x))/(32+9*(1.0/x)*(1.0/x));
	}
	else return (32*x)/(32+9*x*x);
}
/*========================================================================================================================================================*/
float Signat(float x)									  //   sign
{
if (x>0) x=1;//return 1;
	else if(x==0) x=0;//return 0;
	else if(x<0)  x=-1;//return -1;
return x;
}
/*========================================================================================================================================================*/
float MySin(float x)									  //   ( -, - )
{
float		e=0.00000001;
float		y=0;
float		u;
float		z;
uint16_t	k=0;

 			 u=x;
			 z=x*x;
			 while (Module(u)>e) 
					{
						y=y+u;
						k=k+2;
						u=-u*z/(k*(k+1));
					}
	 return y;
}
/*========================================================================================================================================================*/
float radtodeg (float x)								  //    
{
 return x*180/3.1415;
}
/*========================================================================================================================================================*/
float degtorad (float x)								 //    
{
 return x*3.1415/180;
}

