#include	"GlobalVars.h"
#include	"flashFunctions.h"
/*=================================================================================*/
uint8_t	WriteToFlash	(uint32_t addr,uint16_t data)
{
uint8_t	status=0;

FLASH_UnlockBank1();
status=FLASH_ProgramHalfWord(addr,data);
FLASH_LockBank1();  
return status;
}
/*=================================================================================*/
uint16_t	ReadFromFlash	(uint32_t addr)
{
unsigned int	*val;

val=(int*)addr;
return	*val;
}
/*=================================================================================*/
void	InitFlash	(void)
{
uint16_t 	temp;
uint32_t	addr=HR_ADDRESS;
 FLASH_UnlockBank1();
 temp=FLASH_ErasePage(addr);
 temp=WriteToFlash(addr,0x01);
 temp=WriteToFlash(addr+2,MODBUS_SPEED/10);
 addr=addr+4;
while (addr!=(HR_ADDRESS+F_HR_QUANTITY*2))//HR [6..42] = 0
	{
	 temp=WriteToFlash(addr,0);
	 addr=addr+2;
	}
FLASH_LockBank1();
}
/*=================================================================================*/
void MODBUS_OFF	(MODBUS_DATA *MODBUS,USART_TypeDef *USARTx)
{
if (!MODBUS->RECEIVE_FLAG && !MODBUS->TRANSMIT_FLAG)
	{
	 USART_ITConfig(USARTx,USART_IT_TC,DISABLE);
	 USART_ITConfig(USARTx,USART_IT_RXNE,DISABLE);
	}
}
/*=================================================================================*/
void MODBUS_ON	(USART_TypeDef *USARTx)
{
 USART_ITConfig(USARTx,USART_IT_TC,DISABLE);
 USART_ITConfig(USARTx,USART_IT_RXNE,DISABLE);
}