#include "stm32f10x.h"
#include "GPIO.h"
#include "SSD1963_CMD.h"
#include "MySSD1963.h"
/*================================================================*/
/*Fonts Definitions*/
/*================================================================*/
#define	GL_FONT_BIG		0
#define	GL_FONT_SMALL 1

/*================================================================*/
/*Fonts data*/
typedef struct 
{    
  uint8_t*	table;
  uint8_t		*Width;//uint16_t Width;
  uint16_t	*Offset;
	uint16_t Height;
}FONTTYPE;
extern FONTTYPE ARIAL9pt,ARIAL10pt,ARIAL24pt;

extern	FONTTYPE	*CurrentFont;
/*================================================================*/
/*Text functions*/
/*================================================================*/
void 			TFT_WriteChar				(uint16_t Xpos, uint16_t Ypos, const uint8_t *c,uint8_t width,uint8_t height,uint32_t GL_BackGround,uint32_t GL_TextColor);
void 			TFT_WriteCharBig		(uint16_t Xpos, uint16_t Ypos, const uint32_t *c,uint8_t num, uint8_t height,uint32_t GL_BackGround,uint32_t GL_TextColor);
void			TFT_Log							(uint16_t	Xpos, uint16_t Ypos,uint8_t* ptr, uint16_t	BackGround,uint16_t TextColor,FONTTYPE* Font);
uint16_t 	GetStringLenght			(uint8_t* ptr, FONTTYPE* Font);
uint8_t		GetCharWidth				(uint8_t ptr,FONTTYPE* Font);
void			HexToASCII					(unsigned char	hex_data, uint8_t* ptr);
uint8_t		GetChar							(uint8_t* str);
uint8_t		GetStringByWidth		(uint8_t* str1,uint16_t width, FONTTYPE* Font);
void 			itoa								(int n, char s[]);








